/*	
 *	clipt18.h
 *
 *	P/ECE TMS9918(A) Emulator
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2005 Naoyuki Sawa
 *
 *	* Mon Jan 3 13:00:00 JST 2005 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __CLIP_T18_H__
#define __CLIP_T18_H__

/****************************************************************************
 *
 ****************************************************************************/

typedef struct _TMS9918 {
	unsigned short addr;		/* + 0,  2: Address (0x0000-0x3fff) gppx̂1߂ŃANZXł悤擪ɔzu */
	         short latch;		/* + 2,  2: Port#1ւ̏ݒlێ (-1:) */
	unsigned char  reg[8];		/* + 4,  8: Register */
	unsigned char  status;		/* +12,  1: Status */
	unsigned char  resv[3];		/* +13,  3: (\) */
	unsigned char vram[0x4000];	/* +16,16K: VRAM (16KB) */
} TMS9918;

/****************************************************************************
 *
 ****************************************************************************/

/* TMS9918_GRAYSCALEV{`ƁA16~OCXP[o͂ƂȂ܂B
 * TMS9918_GRAYSCALEV{`Ȃ΁A16pbgJ[o͂ƂȂ܂B
 */
#ifdef PIECE
#define TMS9918_GRAYSCALE
#endif /*PIECE*/

#ifdef TMS9918_GRAYSCALE
extern const unsigned char tms9918_grayscale_table[16];
#else /*TMS9918_GRAYSCALE*/
extern const unsigned char tms9918_color_table[16][3/*R,G,B*/];
#endif /*TMS9918_GRAYSCALE*/

/****************************************************************************
 *	gp
 ****************************************************************************/

void tms9918_update_graphics1(TMS9918* tms9918, unsigned char vbuff[/*256 * 192*/]);
void tms9918_update_graphics2(TMS9918* tms9918, unsigned char vbuff[/*256 * 192*/]);
void tms9918_update_multicolor(TMS9918* tms9918, unsigned char vbuff[/*256 * 192*/]);
void tms9918_update_text(TMS9918* tms9918, unsigned char vbuff[/*256 * 192*/]);

void tms9918_update_sprite00(TMS9918* tms9918, unsigned char vbuff[/*256 * 192*/]);
void tms9918_update_sprite01(TMS9918* tms9918, unsigned char vbuff[/*256 * 192*/]);
void tms9918_update_sprite10(TMS9918* tms9918, unsigned char vbuff[/*256 * 192*/]);
void tms9918_update_sprite11(TMS9918* tms9918, unsigned char vbuff[/*256 * 192*/]);

#ifdef TMS9918_GRAYSCALE
extern const unsigned char tms9918_div6_table[15 * 6 + 1];
void tms9918_reduce(unsigned char dst[/*128*88*/], const unsigned char src[/*256*192*/]);
#endif TMS9918_GRAYSCALE

/****************************************************************************
 *	AvP[Vp֐
 ****************************************************************************/

void tms9918_reset(TMS9918* tms9918);
int tms9918_read(TMS9918* tms9918, int mode);
void tms9918_write(TMS9918* tms9918, int mode, int data);
int tms9918_update(TMS9918* tms9918, unsigned char vbuff[/*256 * 192*/]);

#endif /*__CLIP_T18_H__*/
